// Copyright 2023 Yuji Tanaka
// HP : http://galaxystar.image.coocan.jp/
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
struct h_pai{
  int type;  //  牌の種類
        //  万:0-8  ソウ:16-24  ピン:32-40  字:48-54  -1:牌無し
  int naki;  //  ないているか？
        //  0:無し  1:ツモ牌 2:アンカン  3:チー  4:ポン  5:ミンカン
  int group; //  分割グループNo.
        //  -1:分割されていない 0:頭 1以上:カン、なき
  int who;   // 誰からないたか(0-2)
};
struct h_yaku{
  uint16_t name[16];  //  役の名前
  int han;    //  飜
};
struct h_sikou{
  char name[16];  //  名前
  int  num;     //  メンバーの番号
  int  select;
  int  think;   //  思考ルーチン
          //bit1,0 リーチ  00-しない  01-する
          //bit5,4 鳴き    00-ポン、チー、カンしない  01-ポンの後のカンのみ行う
          //               10-役ある場合のみポン、チー  11-常にポン、カン
          //bit9,8 混一色  00-ねらわず  01-10個以上でねらう   10-8個以上でねらう 11-常にねらう
          //bit13,12 全帯公  00-ねらわず  01-12個以上でねらう  10-10個以上でねらう 11-常にねらう
  int  tenpai;    //  テンパイ
  int  honitu;    //  混一色ねらい
  int  chanta;    //  全帯公ねらい
};
struct h_member{
  char name[16];  //  名前
  int  select;
  int  think;   //  思考ルーチン
          //bit1,0 リーチ  00-しない  01-する
          //bit5,4 鳴き    00-ポン、チー、カンしない  01-ポンの後のカンのみ行う
          //               10-役ある場合のみポン、チー  11-常にポン、カン
          //bit9,8 混一色  00-ねらわず  01-10個以上でねらう   10-8個以上でねらう 11-常にねらう
          //bit13,12 全帯公  00-ねらわず  01-12個以上でねらう  10-10個以上でねらう 11-常にねらう
          //bit17,16 捨て牌  00-リーチに関係なく捨てる
          //          01-リーチ一発に特に注意する
          //          10-リーチしたら常に捨て牌気を付ける
  int game;     //  ゲーム回数
  int all_point;  //  30000点基準での合計点数(/100)
  int ryukyoku;   //  流局回数
  int tenpai;   //  テンパイ回数
  int kyoku;    //  局数
  int agari;    //  上がった回数
  int fan;      //  今までに上がった時の飜数の合計
  int furikomi;   //  振り込んだ回数
  int richi;
  int dbl_richi;
  int ipatu;
  int dora;
  int tumo;
  int haitei_tumo;
  int haitei_ron;
  int rinshan;
  int chankan;
  int pinfu;
  int ipeko;
  int tanyao;
  int fanpai;
  int doko3;
  int anko3;
  int kantu3;
  int shou3;
  int honroto;
  int chitoitu;
  int chanta_m;
  int chanta;
  int itu_m;
  int itu;
  int shoku3_m;
  int shoku3;
  int toitoi;
  int junchan_m;
  int junchan;
  int ryanpeko;
  int honitu_m;
  int honitu;
  int chinitu_m;
  int chinitu;
  int nagasi;
  int renho;
  int tenho;
  int chiho;
  int chinroto;
  int kantu4;
  int ryuiso;
  int dai3gen;
  int tuiso;
  int shosusi;
  int daisusi;
  int anko4;
  int kokusimuso;
  int churenpoto;
  int puto13;
  int daisharin;
};
